﻿-- Author: TeeKoo/Truck-King
-- Name: PlayerSetHatEvent.lua
-- Description: event for hat change

-- Modifications only with my permission, Perkele!

-- Changelog:
-- 	v0.0.0.1 (20.1.2021):
--		- first Release
--
-- ToDo:
--

PlayerSetHatEvent = {};
PlayerSetHatEvent_mt = Class(PlayerSetHatEvent, Event);
InitEventClass(PlayerSetHatEvent, "PlayerSetHatEvent");

function PlayerSetHatEvent:emptyNew()
    local self = Event:new(PlayerSetHatEvent_mt)
    return self
end

function PlayerSetHatEvent:new(player, selectedHatIndex)
    local self = PlayerSetHatEvent:emptyNew()
    self.player = player
    self.selectedHatIndex = selectedHatIndex
    return self
end

function PlayerSetHatEvent:readStream(streamId, connection)
    self.player = NetworkUtil.readNodeObject(streamId)
    self.selectedHatIndex = streamReadUInt16(streamId)
    self:run(connection)
end

function PlayerSetHatEvent:run(connection)
    if not connection:getIsServer() then
        g_server:broadcastEvent(self, false, connection, self.player)
    end
    
    self.player:setPlayerHatData(self.selectedHatIndex, true)
end

function PlayerSetHatEvent.sendEvent(player, selectedHatIndex, noEventSend)
    if noEventSend == nil or noEventSend == false then
        if g_server ~= nil then
            g_server:broadcastEvent(PlayerSetHatEvent:new(player, selectedHatIndex), nil, nil, player)
        else
            g_client:getServerConnection():sendEvent(PlayerSetHatEvent:new(player, selectedHatIndex))
        end
    end
end

function PlayerSetHatEvent:writeStream(streamId, connection)
    NetworkUtil.writeNodeObject(streamId, self.player)
    streamWriteUInt16(streamId, self.selectedHatIndex)
end