﻿-- Author: TeeKoo/Truck-King
-- Name: hatChanger
-- Description: Allows you to change hat in the game, saves selected hat to savegame

-- Modifications only with my permission, Perkele!

-- Changelog:
-- 	v0.0.0.1 (20.1.2021):
--		- first Release
--
-- ToDo:
--

local modDirectory = g_currentModDirectory
local manager = nil

source(modDirectory .. "src/HatManager.lua")
source(modDirectory .. "src/PlayerSetHatEvent.lua")

function install()
	if g_hatManager == nil then
		loadManager()
		FSBaseMission.delete = Utils.appendedFunction(FSBaseMission.delete, del)
		source(modDirectory .. "src/HatChanger.lua")
	end
	
	if g_hatManager ~= nil then
		g_hatManager:registerCategory("hats.xml", g_currentModDirectory, g_i18n)
	end
end

function loadManager()
    assert(g_hatManager == nil)

    manager = HatManager:new()
    getfenv(0).g_hatManager = manager
end

function del()
    if manager ~= nil then
        manager:delete()
        manager = nil
        getfenv(0).g_hatManager = nil
    end
end

install()
